/***********************************************************
*
*	main.c
*
*	This is sample program for self-programming.
*
*	history : 2014/11/18	start
*
*   Copyright (C) SEIKO EPSON CORPORATION 2014. All rights reserved.
************************************************************/
/* include */
#include <string.h>
#include "fl_self.h"

/* prototype */
void drawLine(short);
void clearLine(short);
int update(void);

/* extern */
extern unsigned char checkerLineBit[];
extern unsigned char updateLineBit[];

/************************************************************
*	main
*		param    :     none
*   	return   :     1
************************************************************/
int main(void)
{
	int result;

	// update data
	result = update();

	if(result == FLS_E_SUCCESS) {
		// success
		asm("nop");
	}
	else {
		// error
		asm("nop");
	}

	return 1;
}

/************************************************************
*	update
*		param    :     none
*   	return   :     int			error code
************************************************************/
int update(void) {

	int result = 0;

	// erase 0xB000-0xBFFF
	result = flash_erase(0x8000, 4, 4);

	if(result == FLS_E_SUCCESS) {
		// write data to 0xB000
		result = flash_load(0xb000, 64, updateLineBit);
	}
	return result;
}

